--- ./dvi2tty.c	Mon May 27 18:48:17 1996
+++ ./dvi2tty.c@	Tue Jul 16 12:57:03 2002
@@ -243,7 +243,7 @@
 # if defined(VMS)
         main      (int argc, char ** argv); 
 # else
-void    main      (int argc, char ** argv); 
+int    main      (int argc, char ** argv); 
 # endif
 void    setoption (char * optarg);
 void    getargs   (void);
@@ -265,7 +265,7 @@
 #if defined(VMS)
 main(int argc, char **argv)
 #else
-void main(int argc, char **argv)
+int main(int argc, char **argv)
 #endif
 {
 
@@ -328,7 +328,7 @@
         pclose(output);                     /* close pipe to pager            */
 #endif
 
-    exit(0);
+    return 0;
 
 } /* main */
 
--- ./disdvi.c	Mon May 27 18:49:40 1996
+++ ./disdvi.c@	Tue Jul 16 12:53:25 2002
@@ -94,7 +94,7 @@
 #if defined(VMS)
                 main            (int argc, char ** argv);
 #else
-void            main            (int argc, char ** argv);
+int             main            (int argc, char ** argv);
 #endif
 void            bop             (void);
 void            preamble        (void);
@@ -118,7 +118,7 @@
 #if defined(VMS)
      main(int argc, char **argv)
 #else
-void main(int argc, char **argv)
+int main(int argc, char **argv)
 #endif
 {
     register int opcode;                /* dvi opcode                        */
@@ -273,7 +273,7 @@
             }
     }
 
-    exit(0);
+    return 0;
 
 } /* main */
 
--- test2.tex
+++ test2.tex	2000/01/19 00:22:52
@@ -0,0 +1,60 @@
+\documentclass[a4paper]{article}
+\usepackage[latin1]{inputenc}
+\usepackage[T1]{fontenc}
+\usepackage{ngerman}
+\begin{document}
+
+accents: 
+
+\LaTeX
+
+now inline: bla test
+
+now inline: bla test
+
+now inline: bla  test
+
+real spaces~~~xxx
+
+tildes  accent 
+
+German \"a \"u \"A \"U \ss{} {\ss} "a "u "A "U "s 
+
+horizontal 2 -  is -- 
+
+horizontal 3 -  is --- 
+
+ligatures: ffl fi fl Yp
+
+what about vertikal bars |
+
+horizontal bar -
+
+and tildes ~
+
+< funny carrots >
+
+
+so far  not in verbatim (tt font)
+
+\begin{verbatim}
+now in verbatim (tt font)
+accents: 
+\LaTeX
+now inline: bla test
+now inline: bla test
+now inline: bla  test
+real spaces~~~xxx
+tildes  accent \~o
+german Umlauts \"a \"u \"A \"U \ss{} {\ss} "a "u "A "U "s 
+horizontal 2 -  is -- 
+horizontal 3 -  is --- 
+ligatures: ffl fi fl Yp
+what about vertikal bars |
+horizontal bar -
+and tildes ~
+< funny carrots >
+or other symbols: \\ { } [ ] _ ^ ? = ; / . , + * ( ) ' & % $ # " !
+\end{verbatim}
+
+\end{document}
--- dvistuff.c	Mon May 27 21:59:09 1996
+++ dvistuff.c@	Tue Jul 16 15:57:41 2002
@@ -108,6 +108,7 @@
 bool        symbolfont = FALSE; /* true if font is a symbol font             */
 bool        japan = FALSE;      /* switch to japanese fonts ...              */
 bool        mifont = FALSE;
+bool        T1font = FALSE;	/* DC/EC encoding used ? */
 int         jfontnum = 0;
 bool        noffd;              /* if true output ^L instead of formfeed     */
 char *      delim;              /* -bdelim for font switch printing          */
@@ -163,10 +164,10 @@
 linetype    *   findline        (void);
 unsigned long   num             (int);
 long            snum            (int);
-void            dochar          (char);
-void            symchar         (char);
-void            normchar        (char);
-void            outchar         (char);
+void            dochar          (int);
+void            symchar         (int);
+void            normchar        (int);
+void            outchar         (int);
 void            putcharacter    (long);
 void            setchar         (long);
 void            fontdef         (int);
@@ -192,10 +193,10 @@
 linetype    *   findline        (void);
 unsigned long   num             (int size);
 long            snum            (int size);
-void            dochar          (char ch);
-void            symchar         (char ch);
-void            normchar        (char ch);
-void            outchar         (char ch);
+void            dochar          (int ch);
+void            symchar         (int ch);
+void            normchar        (int ch);
+void            outchar         (int ch);
 void            putcharacter    (long charnr);
 void            setchar         (long charnr);
 void            fontdef         (int x);
@@ -362,19 +363,23 @@
     lastline    = currentline;
     firstcolumn = rightmargin;
     if (pageswitchon) {
-        if ((sequenceon ? pagecounter : pagenr) != firstpage->pag) 
+        if ((sequenceon ? pagecounter : pagenr) != firstpage->pag) {
             if (noffd)
                 fprintf(output, "^L\n");
             else
                 putc(FORM, output);
+	}
     }
     else
-        if (backpointer != -1)              /* not FORM at first page   */
+    {
+        if (backpointer != -1) {            /* not FORM at first page   */
             if (noffd)
                 fprintf(output, "^L\n");
             else
                 putc(FORM, output);
+	}
 
+    }
     return;
 
 } /* initpage */
@@ -391,7 +396,7 @@
 
     while ((opcode = (int) get1()) != EOP) {    /* process page until eop */
         if (opcode <= LASTCHAR)
-            dochar((char) opcode);
+            dochar(opcode);
         else if ((opcode >= FONT_00) && (opcode <= FONT_63)) 
             setfont((long) opcode - FONT_00);
         else if (opcode > POST_POST)
@@ -568,7 +573,7 @@
 void printpage(void)
 {
     register int  i, j;
-    register char ch;
+    register unsigned char ch;
 
     if (sptr != 0)
         fprintf(stderr, "dvi2tty: warning - stack not empty at eop.\n");
@@ -646,14 +651,14 @@
 {
 
     register char ch;               /* character to set rule with            */
-    register long saveh, savev;
+    register long saveh = 0;
                               /* rule   --   starts up the recursive routine */
     if (!moving)
         saveh = h;
     if ((ruleht <= 0) || (rulewt <= 0))
         h += rulewt;
     else {
-        savev = v;
+        register long savev = v;
         if ((ruleht / rulewt) > 0)         /* value < 1 truncates to 0 */
             ch = '|';
         else if (ruleht > (lineheight / 2))
@@ -816,11 +821,12 @@
     /* temp->vv < v < temp->next->vv --- temp is above, temp->next is below */
     topd = v - temp->vv;
     botd = temp->next->vv - v;
-    if ((topd < lineheight) || (botd < lineheight))
+    if ((topd < lineheight) || (botd < lineheight)) {
         if (topd < botd)                           /* take best fit */
             return temp;
         else
             return temp->next;
+    }
 
     /* no line fits suitable, generate a new one */
     currentline = getline();
@@ -878,7 +884,7 @@
  * DOCHAR -- Process a character opcode.
  */
 
-void dochar(char ch)
+void dochar(int ch)
 {
  
     if (japan && jfontnum)
@@ -898,7 +904,7 @@
  * SYMCHAR -- Process a character opcode for a symbol font.
  */
 
-void symchar(char ch)
+void symchar(int ch)
 {
 
     switch (ch) {       /* can do a lot more on MSDOS machines ... */
@@ -918,6 +924,7 @@
        case 105: ch = '>'; break;
        case 106: ch = '|'; break;
        case 110: ch = '\\'; break;
+       default: break;
     }
 
     outchar(ch);
@@ -932,9 +939,8 @@
  * NORMCHAR -- Process a character opcode for a normal font.
  */
 
-void normchar(char ch)
+void normchar(int ch)
 {
-
     switch (ch) {
         case 11  :  if (ttfont) 
                         ch = '^';                   /* up symbol       */
@@ -968,45 +974,48 @@
                                   ch = 'l';         /* ligature        */
                     }
                     break;
-        case 16  :  if (!allchar) ch = 'i'; break;
-        case 17  :  if (!allchar) ch = 'j'; break;
-        case 25  :  if (!allchar) {
-                        outchar('s');
-                        ch = 's';
+        case 16  :  if (!allchar) {
+                      if (T1font) outchar(ch = '`'); else ch = 'i';
                     }
-                    break;  /* German double s */
-        case 26  :  if (!allchar) {
-                        outchar('a');
-                        ch = 'e';
+                    break;
+        case 17  :  if (!allchar) {
+                      if (T1font) outchar(ch = '\''); else ch = 'j';
                     }
+                    break;
+        case 25  :  if (!allchar) ch = T1font ? 'i' : 223;
+                    break;  /* German double s */
+        case 26  :  if (!allchar) ch = T1font ? 'j' : 230;
                     break;  /* Dane/Norw ae    */
         case 27  :  if (!allchar) {
+                      if (T1font) outchar(ch = 'f'); else {
                         outchar('o');
                         ch = 'e';
+                      }
                     }
                     break;  /* Dane/Norw oe    */
         case 28  :  if (!allchar) {
-                        if (scascii)
-                            ch = '|';                   /* Dane/Norw /o    */
-                        else
-                            ch = 'o';
+                      if (scascii) ch = '|'; else if (T1font) { outchar('f'); ch = 'i'; } else ch = 248;
                     }
-                    break;
+                    break; /* Dane/Norw /o    */
         case 29  :  if (!allchar) {
-                        outchar('A');
-                        ch = 'E';
+                      if (T1font) { outchar('f'); ch = 'l'; } else ch = 198;
                     }
                     break;  /* Dane/Norw AE    */
         case 30  :  if (!allchar) {
-                        outchar('O');
-                        ch = 'E';
+                      if (T1font) {
+                        outchar('f'); outchar('f'); ch = 'i';
+                      } else {
+                        outchar('O'); ch = 'E';
+                      }
                     }
                     break;  /* Dane/Norw OE    */
         case 31  :  if (!allchar) {
                         if (scascii)
                             ch = '\\';                  /* Dane/Norw /O    */
-                        else
-                            ch = 'O';
+                        else if (T1font) {
+                           outchar('f'); outchar('f'); ch = 'l';
+                        } else
+                            ch = 216;
                     }
                     break;
         case 32  :  ch = allchar || ttfont ? ch : '_'; break;
@@ -1017,7 +1026,7 @@
         case 123 :  ch = allchar || ttfont ? ch : '-'; break;  /* { from -- */
         case 124 :  ch = allchar || ttfont ? ch : '_'; break;  /* | from --- */
         case 125 :  ch = allchar || ttfont ? ch : '"'; break;  /* } from \H */
-        case 126 :  ch = allchar || ttfont ? ch : '"'; break;  /* ~ from \~ */
+        case 126 :  ch = allchar || ttfont ? ch : '~'; break;  /* ~ from \~ */
         case 127 :  if (!allchar) ch = '"'; break;             /* DEL from \" */
        
         /*
@@ -1034,6 +1043,7 @@
                                                                 /* ^ from \^ */
         case 95  :  ch = (!allchar && accent && !ttfont) ? '`' : ch; break;
                                                                 /* _ from \. */
+        default: break;
     }
     outchar(ch); 
 
@@ -1050,7 +1060,7 @@
  *            SHOULD BE MOVED OUT.
  */
 
-void outchar(char ch)
+void outchar(int ch)
 {
     register int i, j;
 
@@ -1122,6 +1132,30 @@
     }
     /*----------------- end of 'Scandinavian code' ----------------*/
 
+    /*------------------ German umlauts OT1 -----------------------*/
+    if (accent && !ttfont) {
+	if ((ch == 'a') || (ch == 'A') || (ch == 'o') || (ch == 'O') ||
+	    (ch == 'u') || (ch == 'U')) {
+	    for (i = IMAX(leftmargin, j-2); i <= IMIN(rightmargin, j+2); i++)
+		if ((currentline->text[i - leftmargin] == 127) || /* DEL */
+		    (currentline->text[i - leftmargin] == 34))    /* "   */
+                     foo = i;
+             if (foo >= leftmargin) {
+                 j = (int) foo;
+                 switch (ch) {
+                     case 'a': ch = 228; break;
+                     case 'A': ch = 196; break;
+                     case 'o': ch = 246; break;
+                     case 'O': ch = 214; break;
+                     case 'u': ch = 252; break;
+                     case 'U': ch = 220; break;
+                 }
+             }
+         }
+     }
+    /*--------------- end of German umlauts OT1 -------------------*/
+
+
     if (foo == leftmargin-1)
         while ((currentline->text[j - leftmargin] != SPACE)
                && (j < rightmargin)) {
@@ -1179,9 +1213,27 @@
 
 void setchar(long charnr)
 {
+    if( !allchar && T1font )
+      switch( charnr ) {
+ 	/*   DC -> ISO latin 8859-1 */
+ 	case 255: charnr = 223; break;	/* LATIN SMALL LETTER SHARP S */
+ 	case 184: charnr = 255; break;  /* LATIN SMALL LETTER Y WITH DIAERESI */
+ 	case 190: charnr = 191; break;  /* INVERTED QUESTION MARK */
+ 	case 189: charnr = 161; break;  /* INVERTED EXCLAMATION MARK */
+ 	case 191: charnr = 163; break;  /* POUND SIGN */
+ 	case 159: charnr = 167; break;  /* SECTION SIGN */
+ 	/*   DC Ligatures */
+ 	case 223: outchar('S'); charnr = 'S'; break;  /* UPPER LETTER SHARP S */
+ 	case 247: outchar('o'); charnr = 'e'; break;  /* Dane/Norw oe */
+ 	case 215: outchar('O'); charnr = 'E'; break;  /* Dane/Norw OE */
+ 	case 188: outchar('i'); charnr = 'j'; break;  /* Ligature ij  */
+ 	case 156: outchar('I'); charnr = 'J'; break;  /* Ligature IJ  */
+ 	/*   DC -> ISO latin 8859-2 */
+ 	/* Sorry, skipped */
+ 	default : break;
+      }
 
-    outchar(allchar ? charnr : '#');
-
+    outchar(charnr);
     return;
 
 } /* setchar */
@@ -1258,6 +1310,7 @@
     symbolfont = FALSE;
     ttfont = FALSE;
     mifont = FALSE;
+    T1font = FALSE;
     jfontnum = 0;
     if (fnt == NULL) {
         /* error : font not found */
@@ -1277,6 +1330,20 @@
     if (japan)
         jfontnum = getjsubfont(s);
     if (jfontnum == 0) {
+
+        if ((s = strrchr(s, '8')) != NULL) {
+	    int len = strlen(s);
+            if (len >= 2 || len <=3)
+                T1font = TRUE;
+        }
+
+        s = fnt->name;
+	if (strncmp("ec", s, 2) == 0 ||
+	    strncmp("dc", s, 2) == 0 ||
+	    strncmp("tc", s, 2) == 0 )
+	    T1font = TRUE;
+
+        s = fnt->name;
         while ((s = strchr(s, 's')) != NULL) {
             if (strncmp("sy", s, 2) == 0) {
                 symbolfont = TRUE;
--- Makefile	Sun Jul 23 14:04:43 1995
+++ Makefile@	Tue Jul 16 16:09:44 2002
@@ -12,8 +12,8 @@
 # CFLAGS = -Wall -O2 -fomit-frame-pointer
 LDFLAGS = -s
 
-prefix = /usr/local
-mandir = $(prefix)/man/man1
+prefix ?= /usr
+mandir = $(prefix)/man/man1
 bindir = $(prefix)/bin
 
 
@@ -36,4 +36,5 @@
 
 install:	all
 	install dvi2tty disdvi $(bindir)
-	install dvi2tty.1 $(mandir)
+	install -m 644 dvi2tty.1 $(mandir)
+	install -m 644 disdvi.1 $(mandir)
